library(mnist)
data(mnist)

pca <- prcomp(mnist$train$x)

predictions <- predict(pca, mnist$test$x)
reconstructions <- tcrossprod(predict(pca, mnist$test$x)[,1:2], pca$rotation[,1:2])
mean.error <- mean(sqrt(rowMeans((reconstructions - mnist$test$x)^2)))

png("pca.png", width = 1280, height = 720) # hd output
plot.mnist(
	prediction = predictions,
	reconstruction = reconstructions,
	highlight.digits = c(72, 3, 83, 91, 6688, 7860, 92, 1, 180, 13))
par(family="mono")
legend("bottomleft", legend = sprintf("Mean error = %.3f", mean.error), bty="n", cex=3)
dev.off()
